local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local _

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff

x.LastSoulburn = GetTime()

-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()
	x.InCombat = s.InCombat()
	x.TimeToDie = s.TimeToDie("target") or 10
	x.HasPandemic = s.HasSpell(131973--[[Pandemic]])
	local spec = s.Spec()
	a.Flash("Dark Intent")
	a.Flash("Pet Attack")
	a.Flash("Pet Assist")
	a.Flash("Banish")
	a.Flash("Create Healthstone", "Create Soulwell")
	a.Flash("Soulshatter")
	a.Flash("Dark Regeneration")
	a.FlashAll("Flask of the Warm Sun", "Mogu Fish Stew", "Prepot")
--	a.Flash("Unbound Will")
	if spec == 1 then
		-- Affliction
		x.TickSpeed = a.getHastedTickTime(2)
		x.UATicks = a.getTotalTicks(7)
		x.CorruptionTicks = a.getTotalTicks(9)
		x.AgonyTicks = a.getTotalTicks(12)
		x.Metamorphosis = false
		a.Flash("Summon Felhunter ooc", "Grimoire of Sacrifice")
		a.Flash("Curse of Exhaustion")
		a.Flash("Curse of the Elements",
		        "Potion with Bloodlust or Boss HP <= 20",
		        "Dark Soul: Misery",
				"Grimoire: Felhunter",
				"Summon Doomguard", "Summon Terrorguard",
				"Soul Swap with Soulburn",
				"Haunt",
				"Soulburn with Dark Soul",
				"Soulburn under 20%",
				"Agony refresh early if not channeling",
				"Corruption refresh early if not channeling",
				"Unstable Affliction refresh early if not channeling",
				"Agony",
				"Corruption",
				"Unstable Affliction",
				"Drain Soul as finisher",
				"Life Tap if mana < 35%",
				"Malefic Grasp",
				"Life Tap while moving if mana < 80%",
				"Fel Flame while moving")
	elseif spec == 2 then
		-- Demonology
		x.CorruptionSpeed = a.getHastedTickTime(2)
--		x.DoomTicksRemain = s.MyDebuffDuration(603--[[Doom]], "target") / a.getHastedTickTime(15)
		x.CorruptionTicks = a.getTotalTicks(9)
--		x.DoomTicks = a.getTotalTicks(6)
		x.ShadowBoltCastTime = s.CastTime(686--[[Shadow Bolt]])
		x.CorruptionRemaining = s.MyDebuffDuration(172--[[Corruption]], "target")
		x.Metamorphosis = s.Buff(103958--[[Metamorphosis]], "player")
		x.DemonicFury = s.Power("player", SPELL_POWER_DEMONIC_FURY)
		x.DarkSoul = s.Buff(113861--[[Dark Soul: Knowledge]], "player")
		x.DarkSoulRemains = s.BuffDuration(113861--[[Dark Soul: Knowledge]], "player")
		x.SoulFireCondition = (x.DarkSoulRemains < x.ShadowBoltCastTime or x.DarkSoulRemains > s.CastTime(6353--[[Soul Fire]]))
		a.Flash("Summon Felguard ooc", "Grimoire of Sacrifice")
		a.Flash("Carrion Swarm")
		a.Flash("Falling Meteor")
		a.Flash("Curse of the Elements",
		        "Potion with Bloodlust or Boss HP <= 20",
		        "Dark Soul: Knowledge",
				"Grimoire: Felguard",
				"Felstorm", "Wrathstorm",
				"Summon Doomguard", "Summon Terrorguard",
				"Touch of Chaos if Corruption < 1.5sec",
				"Doom",
				"Touch of Chaos if Corruption < 20sec",
				"Cancel Metamorphosis",
				"Soul Fire in Metamorphosis",
				"Touch of Chaos",
				"Corruption (Demo)",
				"Metamorphosis",
				"Hand of Gul'dan",
				"Soul Fire",
				"Molten Core",
				"Life Tap if mana < 60%",
				"Shadow Bolt",
				"Fel Flame while moving")
	elseif spec == 3 then
		-- Destruction
		x.DarkSoulRemains = s.BuffDuration(113858--[[Dark Soul: Instability]], "player")
		x.BurningEmbers = UnitPower("player", SPELL_POWER_BURNING_EMBERS, true)
		x.ImmolateSpeed = a.getHastedTickTime(3)
		x.ImmolateTicks = a.getTotalTicks(5)
		x.Metamorphosis = false
		a.Flash("Summon Felhunter ooc", "Grimoire of Sacrifice")
		a.Flash("Curse of the Elements",
		        "Potion with Bloodlust or Boss HP <= 20",
		        "Dark Soul: Instability",
				"Grimoire: Felhunter", "Grimoire of Sacrifice",
				"Summon Felhunter (Sacrifice down)",
				"Summon Doomguard", "Summon Terrorguard",
				"Shadowburn",
				"Immolate",
				"Chaos Bolt early",
				"Conflagrate",
				"Incinerate",
				"Chaos Bolt as fallback")
	end
end)

